/*******************************************************************
 * This file is part of the Emulex Linux Device Driver for         *
 * Fibre Channel Host Bus Adapters.                                *
 * Copyright (C) 2003-2008 Emulex.  All rights reserved.           *
 * EMULEX and SLI are trademarks of Emulex.                        *
 * www.emulex.com                                                  *
 *                                                                 *
 * This program is free software; you can redistribute it and/or   *
 * modify it under the terms of version 2 of the GNU General       *
 * Public License as published by the Free Software Foundation.    *
 * This program is distributed in the hope that it will be useful. *
 * ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND          *
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,  *
 * FITNESS FOR A PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE      *
 * DISCLAIMED, EXCEPT TO THE EXTENT THAT SUCH DISCLAIMERS ARE HELD *
 * TO BE LEGALLY INVALID.  See the GNU General Public License for  *
 * more details, a copy of which can be found in the file COPYING  *
 * included with this package.                                     *
 *******************************************************************/

/* 
 * $Id: mpl_crtn.h 1474 2008-04-07 21:11:34Z mukumar $
 */

extern void mpl_module_lock(void);
extern void mpl_module_unlock(void);
extern unsigned char *mpl_find_cmnd_data(struct scsi_cmnd *, int *);
extern void mpl_release_cmnd_data(struct scsi_cmnd *);
extern int mpl_vendor_hp_check(struct scsi_cmnd *);
extern void mpl_restart_sched_cmd(struct mpl_path *, unsigned long);
extern void mpl_restart_pendq_timer(struct mpl_device *, unsigned long);
extern void mpl_set_cmd_path(struct scsi_cmnd *, struct mpl_path *);
extern void mpl_cmd_timeout(unsigned long);
extern void mpl_scsi_timesout(unsigned long);
extern struct io_stub *mpl_setup_inquiry(struct mpl_path *, unsigned char);
extern struct io_stub *mpl_setup_startstop(struct mpl_path *);
extern struct io_stub *mpl_setup_tur(struct mpl_path *);
extern struct io_stub *mpl_setup_report_tgt_port(struct mpl_path *);
extern struct io_stub *mpl_setup_set_tgt_port(struct mpl_path *, int, int);
extern void mpl_send_internal_cmd(struct mpl_path *, struct io_stub *);
extern void mpl_send_internal_completion(struct mpl_path *, struct io_stub *,
					 void (*done)(struct scsi_cmnd *));
extern void mpl_call_done_free_stub(struct io_stub *);
extern void mpl_path_schedule_cmd(unsigned long);
extern void mpl_path_set_active(struct mpl_path *, int);
extern void mpl_path_flip_all_active(struct mpl_path *);
extern void mpl_device_process_pendq(struct mpl_device *);
extern void mpl_pendq_timeout_fn(unsigned long);
extern void mpl_process_internal_cmd(struct io_stub *);
extern void mpl_process_hbeat_cmd(struct io_stub *);
extern char *mpl_print_host(struct mpl_host *);
extern char *mpl_print_device(struct mpl_device *);
extern char *mpl_print_path(struct mpl_path *);
extern void  mpl_hbeat_state_machine(struct mpl_path *,
				     enum mpl_hb_event event);
extern void mpl_path_state_machine(struct mpl_path *, enum mpl_path_event);
extern void mpl_device_state_machine(struct mpl_device *,
				     struct mpl_path *,
				     enum mpl_device_event);

extern void mpl_stub_switch_path(struct io_stub *, struct mpl_path *);
extern struct io_stub *mpl_find_stub_remove(struct scsi_cmnd *);
extern struct io_stub *mpl_find_stub_remove_quiet(struct scsi_cmnd *);
extern int    mpl_find_stub_in_hash(struct io_stub *);
extern struct io_stub *mpl_get_first_pend_io(struct mpl_device *);
extern void mpl_inc_can_queue(struct io_stub *);
extern void  mpl_dec_can_queue(struct io_stub *);
extern void mpl_done(struct scsi_cmnd *);
extern void mpl_internal_done(struct scsi_cmnd *);
extern int (*mpl_base_queuecommand)(struct scsi_cmnd *, void (*done)(struct scsi_cmnd *));
extern void mpl_set_cmd_timer(struct io_stub *, int);
extern char *mpl_print_wwpn(unsigned char *);
extern int mpl_get_tgt_wwinfo(void *, uint32_t, struct mpl_target *);
extern int mpl_host_is_offline(void *);
extern void mpl_get_hba_wwpn(void *, uint8_t *);
extern void *mpl_get_ndlp(void *);
extern void mpl_do_clear_ndlp(void *);
extern void mpl_do_set_ndlp(void *, uint32_t, void *);
extern int mpl_get_hba_nodev_tmo(void *);
extern int mpl_get_validation_id(char *, char *, int *);
extern int mpl_get_scsi_page83_serial(char *, struct scsi_id_search_values *,
		int, char *, int *);
extern int mpl_crack_serial_number(uint8_t *, size_t, char *);
extern unsigned short mpl_get_lun_q_depth(struct mpl_host *);
extern void mpl_free_initial_data(void);
extern struct config_path *mpl_get_path_flags(int *, uint8_t host_wwpn[8],
			      uint8_t target_wwpn[8], int);
extern struct config_path *mpl_get_device_flags_by_sn(int *, uint8_t *, int); 
extern void mpl_wake_thread(void);
extern void mpl_wake_eh_thread(void);
extern void mpl_destroy_mem_pool(void);

extern struct io_stub *mpl_find_stub_in_lpfcq(struct io_stub *);
extern struct io_stub *mpl_find_scsi_cmd_in_lpfcq(struct scsi_cmnd *, int);
extern void mpl_add_stub_to_lpfcq(struct io_stub *);
extern void mpl_remove_stub_from_lpfcq(struct io_stub *);
extern struct io_stub *mpl_get_first_lpfcq(struct mpl_host *);
extern struct io_stub *mpl_find_stub_in_pendq(struct io_stub *);
extern struct io_stub *mpl_find_scsi_cmd_in_pendq(struct scsi_cmnd *, int);
extern void mpl_add_stub_to_pendq(struct io_stub *);
extern void mpl_remove_stub_from_pendq(struct io_stub *);
extern struct io_stub *mpl_get_first_pendq(struct mpl_device *);
extern struct io_stub *mpl_find_stub_in_deferral(struct io_stub *);
extern struct io_stub *mpl_find_scsi_cmd_in_deferral(struct scsi_cmnd *, int);
extern void mpl_add_stub_to_deferral(struct io_stub *);
extern void mpl_remove_stub_from_deferral(struct io_stub *);
extern struct io_stub *mpl_get_first_deferral(void);
extern struct io_stub *mpl_find_stub_in_hbeat_deferral(struct io_stub *);
extern void mpl_add_stub_to_hbeat_deferral(struct io_stub *);
extern void mpl_remove_stub_from_hbeat_deferral(struct io_stub *);
extern struct io_stub *mpl_get_first_hbeat_deferral(struct mpl_host *) ;
extern struct io_stub *mpl_find_stub_in_eh_deferral(struct io_stub *);
extern struct io_stub * mpl_find_scsi_cmd_in_eh_deferral(struct scsi_cmnd *, int);
extern struct io_stub * mpl_find_devloss_tmo_in_eh_deferral(uint64_t );
extern void mpl_add_stub_to_eh_deferral(struct io_stub *);
extern void mpl_remove_stub_from_eh_deferral(struct io_stub *);
extern struct io_stub *mpl_get_first_eh_deferral(void);
extern struct io_stub *mpl_get_first_scsitmo_deferral(void);
extern struct io_stub *mpl_find_stub(struct scsi_cmnd *);
extern struct io_stub *mpl_match_cmnd_remove_stub(struct scsi_cmnd *, int);
extern struct io_stub *mpl_find_scsi_cmd_in_anyq(struct scsi_cmnd *, int);

extern void mpl_add_stub_to_scsitmo_deferral(struct io_stub *);
extern struct io_stub *mpl_find_stub_in_scsitmo_deferral(struct io_stub *);
extern struct io_stub *mpl_match_cmnd_remove_from_scsitmo_deferral(struct scsi_cmnd  *);

#ifdef MPL_SCSICMD_SANITY
extern void mpl_add_stub_to_scsiglobal(struct io_stub *);
extern struct io_stub *mpl_find_stub_in_scsiglobal(struct io_stub *);
extern void mpl_remove_stub_from_scsiglobal(struct io_stub *);
#endif
